﻿//   LSG Series GP-IB Sample Program　for VC# 2008 or Higher

//   Please Open project (LSG_Access.csproj), NOt Open Solution
//   Remove Rerences for NationalInstrument common and NI488.2
//   Add References NationalInstrument common and NI488.2 on Youre PC

//   ソリューションファイルでなくプロジェクトファイル(LSG_Access.csproj)を開いてください。
//   ナショナルインスツルメンツのライブラリの参照がおかしい場合は参照をやり直してください。


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using NationalInstruments.NI4882;

namespace LSG_Access
{
    public partial class LSG_Access : Form
    {
        private Device device;
        private int Opened;

        // Open Window
        public LSG_Access()
        {
            InitializeComponent();

            Opened = 0;
            for (int i = 1; i < 30; i++)
                cmbAddress.Items.Add(i);
            cmbAddress.SelectedIndex = 0;

            // Set form
            btnOpen_Close.Text = "OPEN";
            btnLoad.Enabled = false;
            btnCCmode.Enabled = false;
            btnCPmode.Enabled = false;
            btnCRmode.Enabled = false;
            btnCVmode.Enabled = false;
            btnMonitor.Enabled = false;
            btnValueSet.Enabled = false;
            cmbAddress.Enabled = true;
        }

        // Form Close(x Button)
        private void Form1_FormClosing(object sender,FormClosingEventArgs e)
        {
            // Device Close
            if(cmbAddress.Enabled == false)
                device.Write(":INP OFF;:UTIL:REM OFF\n");

            if( Opened != 0)
                device.Dispose();

        }
        // Open/Close Button
        private void btnOpen_Close_Click(object sender, EventArgs e)
        {
            if(btnOpen_Close.Text == "OPEN"){
                try
                {
                    int BourdId = 0 ;
                    Opened = 1;
                    Cursor.Current = Cursors.WaitCursor;
                    // Device Open and Init
                    device = new Device(BourdId, (byte)(cmbAddress.SelectedIndex + 1));
                    device.Write("*cls;:INP OFF;:MODE CC;:INP:MODE LOAD;:MODE:CRAN HIGH;:MODE:VRAN HIGH;:UTIL:LOAD:MODE OFF\n");
                    lblUnit.Text = "A";
                    btnLoad.Text = "LOAD ON";

                    // Set form
                    btnOpen_Close.Text = "CLOSE";
                    btnLoad.Enabled = true;
                    btnCCmode.Enabled = true;
                    btnCPmode.Enabled = true;
                    btnCRmode.Enabled = true;
                    btnCVmode.Enabled = true;
                    btnMonitor.Enabled = true;
                    btnValueSet.Enabled = true;
                    cmbAddress.Enabled = false;

                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
                finally
                {
                    Cursor.Current = Cursors.Default;
                }
            }
            else{
                try
                {
                    // Device Close
                    device.Write(":INP OFF;:UTIL:REM OFF\n");
                    device.Dispose();

                    // Set form
                    btnOpen_Close.Text = "OPEN";
                    btnLoad.Enabled = false ;
                    btnCCmode.Enabled = false ;
                    btnCPmode.Enabled = false ;
                    btnCRmode.Enabled = false ;
                    btnCVmode.Enabled = false ;
                    btnMonitor.Enabled = false ;
                    btnValueSet.Enabled = false ;
                    cmbAddress.Enabled = true ;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }

        }
        
        // CC Button
        private void btnCCmode_Click(object sender, EventArgs e)
        {
            device.Write(":MODE CC\n");
            lblUnit.Text  = "A";
        }

        // CP Button
        private void btnCPmode_Click(object sender, EventArgs e)
        {
            device.Write(":MODE CP\n");
            lblUnit.Text = "W";
        }

        // CR Button
        private void btnCRmode_Click(object sender, EventArgs e)
        {
            device.Write(":MODE CR\n");
            lblUnit.Text = "mS";
        }

        // CV Button
        private void btnCVmode_Click(object sender, EventArgs e)
        {
            device.Write(":MODE CV\n");
            lblUnit.Text = "V";
        }

        // Load Button
        private void btnLoad_Click(object sender, EventArgs e)
        {
            if (btnLoad.Text == "LOAD ON")
            {
                // OFF -> ON
                device.Write(":INP ON\n");
                btnLoad.Text = "LOAD OFF";
            }
            else
            {
                // ON -> OFF
                device.Write(":INP OFF\n");
                btnLoad.Text = "LOAD ON";
            }
        }

        // Set Button
        private void btnValueSet_Click(object sender, EventArgs e)
        {
            string SendMsg = "";
            if (lblUnit.Text == "A") SendMsg = ":CURR ";
            else if (lblUnit.Text == "W") SendMsg = ":POW ";
            else if (lblUnit.Text == "V") SendMsg = ":VOLT ";
            else if (lblUnit.Text == "mS") SendMsg = ":RES ";
            else SendMsg = "";

            if (SendMsg != "")
            {
                SendMsg = SendMsg + ReplaceCommonEscapeSequences(txtValue.Text);
                try
                {
                    device.Write(SendMsg);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
         }

        // Monitor Button
        private void btnMonitor_Click(object sender, EventArgs e)
        {
            string txtVoltage, txtCurrent, txtPower;
            try
            {
                Cursor.Current = Cursors.WaitCursor;
                device.Write(":MEAS:VOLT?\n");
                txtVoltage = device.ReadString() + "V\r\n";
                device.Write(":MEAS:CURR?\n");
                txtCurrent = device.ReadString()+ "A\r\n";
                device.Write(":MEAS:POW?\n");
                txtPower = device.ReadString()+"W\r\n";
                txtMeasure.Text = txtCurrent + txtVoltage + txtPower;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                Cursor.Current = Cursors.Default;
            }
        }

        private string ReplaceCommonEscapeSequences(string s)
        {
            return s.Replace("\\n", "\n").Replace("\\r", "\r");
        }

        private string InsertCommonEscapeSequences(string s)
        {
            return s.Replace("\n", "\\n").Replace("\r", "\\r");
        }
    }
}
